<template lang="pug">

mixin Param
  Param.col-12.col-sm-6.col-lg-4&attributes(attributes)

mixin ParamReadonly
  ParamReadonly.col-12.col-sm-6.col-lg-4&attributes(attributes)

.col-12.col-sm-6.pb-3
  Card(tabIndex="-1" ref="mainCard").highlightOnFocus
    template(v-slot:header)
      .d-flex.justify-content-between
        div #[h5 Timing]
        .ml-auto.clickable(v-if='!$utils.isEmpty(dns) && !inEdit'
                           @click='setEdit(true)')
          kbd.keyHint.mr-2(v-if="showKeyHints") E
          i.fa.fa-cog
        .ml-auto.clickable(v-if='inEdit'
                           @click='setEdit(false)')
          kbd.keyHint.mr-2(v-if="showKeyHints") Esc
          i.fa.fa-times
    li(key="0")
      .row
        .col
          strong Timing Status
          .alert(:class="alertClass" role='alert')
            h6.m-1(align='center' v-if='!inEdit') {{ getModeName(currentMode)||defaultString }}
            .input-group.mb-3(v-if='inEdit')
              .input-group-prepend
                button.btn.btn-outline-secondary.dropdown-toggle.dropdown-toggle-split(type='button' data-toggle='dropdown' aria-haspopup='true' aria-expanded='false')
                  span.sr-only Toggle Dropdown
                .dropdown-menu
                  .dropdown-item.clickable(v-for='mode in availableModes' @click='setMode(mode.value)') {{ mode.name }}
              input.form-control.x-input-timing(type='text' :value='getModeName(editMode)')
    li(key="1" v-if='isCalib')
      .row
        .col
          .row.b-param-container.justify-content-center
            i.fa.fa-question-circle(@click="calibHelpVisible = !calibHelpVisible")
          .row.b-param-container.justify-content-center
            .col-12.col-xl-8
              AnimBlock(anim='height')
                img(v-if="calibHelpVisible" :style="{ height: 'auto', width: '100%' }" :src="$utils.publicPath('img/Timing-calib.svg')")
    li(key='2' v-if='isCalib || inEdit')
      .row
        .col-12
          .row.b-param-container(v-if="isCalib")
            +Param(ref='period' title='Period [ms]' :inEdit='inEdit' :value='triggerPeriod')
            +Param(ref='repeat' title='Repeat' :inEdit='inEdit' :value='triggerRepeat')
            +Param(ref='pause' title='Pause [ms]' :inEdit='inEdit' :value='triggerPause')
          .row.b-param-container(v-else)
            +ParamReadonly(ref='period' title='Period [ms]' :inEdit='inEdit' :value='triggerPeriod')
            +ParamReadonly(ref='repeat' title='Repeat' :inEdit='inEdit' :value='triggerRepeat')
            +ParamReadonly(ref='pause' title='Pause [ms]' :inEdit='inEdit' :value='triggerPause')
    li(key="3" v-if='inEdit')
      .row.justify-content-center
        .col-auto
          button.btn.btn-primary.mx-1(type='submit' @click='submitEdit()')
            kbd.keyHint.mr-2(v-if="showKeyHints") Ctrl+S
            | Submit
        .col-auto
          button.btn.btn-secondary.mx-1(type='submit' @click='cancel()')
            kbd.keyHint.mr-2(v-if="showKeyHints") Esc
            | Cancel

    template(v-slot:footer v-if='!$utils.isEmpty(dns) && showEventCount')
      .row
        .col-12
          div(:class="{ 'text-muted': !isRunning }") #[strong Event number:] {{ eventNumber }}
</template>
<script>

export { default } from './Timing.vue.js';

</script>

<style lang="scss">

[theme=dark] {
  .x-input-timing {
    color: black !important;
  }
}

</style>>

</style>